CompositeGuardingDynamicLinker (Java SE 26 & JDK 26)
Description: declaration: module: jdk.dynalink, package: jdk.dynalink.linker.support, class: CompositeGuardingDynamicLinker
Keywords: jdk.dynalink.linker.support.CompositeGuardingDynamicLinker class

# Class CompositeGuardingDynamicLinker

java.lang.Object
jdk.dynalink.linker.support.CompositeGuardingDynamicLinker

All Implemented Interfaces:
  `GuardingDynamicLinker`

public class CompositeGuardingDynamicLinker extends Object implements GuardingDynamicLinker
A `GuardingDynamicLinker` that delegates sequentially to a list of other guarding dynamic linkers in its `getGuardedInvocation(LinkRequest, LinkerServices)`.

Since:
  9

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CompositeGuardingDynamicLinker(Iterable<? extends GuardingDynamicLinker> linkers)`
  Creates a new composite linker.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `GuardedInvocation`
  `getGuardedInvocation(LinkRequest linkRequest, LinkerServices linkerServices)`
  Delegates the call to its component linkers.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### CompositeGuardingDynamicLinker

    public CompositeGuardingDynamicLinker(Iterable<? extends GuardingDynamicLinker> linkers)
    Creates a new composite linker.
    Parameters:
      `linkers` - a list of component linkers.
    Throws:
      `NullPointerException` - if `linkers` or any of its elements are null.

- ## Method Details

  - ### getGuardedInvocation

    public GuardedInvocation getGuardedInvocation(LinkRequest linkRequest, LinkerServices linkerServices) throws Exception
    Delegates the call to its component linkers. The first non-null value returned from a component linker is returned. If no component linker returns a non-null invocation, null is returned.
    Specified by:
      `getGuardedInvocation` in interface `GuardingDynamicLinker`
    Parameters:
      `linkRequest` - the object describing the request for linking a particular invocation
      `linkerServices` - linker services
    Returns:
      the first non-null return value from a component linker, or null if none of the components returned a non-null.
    Throws:
      `Exception` - if the operation fails for whatever reason